import { a as push, b as attr, s as store_get, e as escape_html, u as unsubscribe_stores, h as bind_props, p as pop } from "./index2.js";
import { p as page } from "./stores.js";
import { g as getBestThumbnail } from "./images.js";
import "human-number";
import { Capacitor } from "@capacitor/core";
import "@capacitor/screen-orientation";
import "@capacitor/status-bar";
import "@hugotomazi/capacitor-navigation-bar";
import "googlevideo";
import "iso-639-1";
import "mousetrap";
import "shaka-player/dist/shaka-player.ui.js";
import "sponsorblock-api";
import { o as onDestroy } from "./index-server.js";
import "./runtime.js";
import { g as get } from "./index.js";
import "bgutils-js";
import "youtubei.js";
import { n as playerAutoPlayStore, f as playerProxyVideosStore, p as playerSavePlaybackPositionStore } from "./store.js";
import "buffer";
import "./beer.min.js";
function Player($$payload, $$props) {
  push();
  var $$store_subs;
  let {
    data,
    isEmbed = false,
    segments = [],
    playerElement = void 0
  } = $$props;
  let snackBarAlert = "";
  let player;
  let shakaUi;
  function loadTimeFromUrl(page2) {
    return false;
  }
  page.subscribe((pageUpdate) => loadTimeFromUrl());
  get(playerProxyVideosStore);
  function savePlayerPos() {
    if (data.video.hlsUrl) return;
    if (get(playerSavePlaybackPositionStore) && player) ;
  }
  onDestroy(async () => {
    if (Capacitor.getPlatform() === "android") ;
    try {
      savePlayerPos();
    } catch (error) {
    }
    await playerElement.pause();
    await player.destroy();
    await shakaUi.destroy();
  });
  $$payload.out += `<div id="shaka-container" class="youtube-theme" style="max-height: 80vh; max-width: calc(80vh * 16 / 9); overflow: hidden; position: relative; flex: 1; background-color: black;" data-shaka-player-container=""><video${attr("controls", false, true)}${attr("autoplay", store_get($$store_subs ??= {}, "$playerAutoPlayStore", playerAutoPlayStore), true)} id="player" style="width: 100%; height: 100%; object-fit: contain;"${attr("poster", getBestThumbnail(data.video.videoThumbnails, 1251, 781))}></video></div> `;
  if (!isEmbed) {
    $$payload.out += "<!--[-->";
    $$payload.out += `<div class="snackbar" id="snackbar-alert"><span class="bold" style="text-transform: capitalize;">${escape_html(snackBarAlert)}</span></div>`;
  } else {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]-->`;
  if ($$store_subs) unsubscribe_stores($$store_subs);
  bind_props($$props, { segments, playerElement });
  pop();
}
export {
  Player as P
};
