import { a as push, s as store_get, b as attr, d as attr_class, e as escape_html, u as unsubscribe_stores, p as pop, k as copy_payload, l as assign_payload, h as bind_props, n as head, o as await_block, c as ensure_array_like } from "../../../../../chunks/index2.js";
import "../../../../../chunks/client.js";
import { c as getPlaylist } from "../../../../../chunks/index3.js";
import "bgutils-js";
import "youtubei.js";
import { n as numberWithCommas, c as cleanNumber } from "../../../../../chunks/numbers.js";
import { i as interfaceLowBandwidthMode, a as activePageStore, o as playlistSettingsStore, q as syncPartyConnectionsStore, s as syncPartyPeerStore, b as authStore, t as playerTheatreModeByDefaultStore } from "../../../../../chunks/store.js";
import "@capacitor/core";
import "buffer";
import { p as proxyGoogleImage, g as getBestThumbnail } from "../../../../../chunks/images.js";
import { h as html } from "../../../../../chunks/html.js";
import { P as Player } from "../../../../../chunks/Player.js";
import "@capacitor/clipboard";
import { $ as $format } from "../../../../../chunks/runtime.js";
import "clsx";
import { T as Thumbnail } from "../../../../../chunks/Thumbnail.js";
import { g as get } from "../../../../../chunks/index.js";
import { t as truncate } from "../../../../../chunks/misc.js";
import { l as letterCase } from "../../../../../chunks/letterCasing.js";
import "../../../../../chunks/beer.min.js";
import { o as onDestroy, t as tick } from "../../../../../chunks/index-server.js";
function Comment($$payload, $$props) {
  push();
  var $$store_subs;
  let { comment, videoId } = $$props;
  const replyText = comment.replies?.replyCount > 1 ? "replies" : "reply";
  function commentTimestamps(html2) {
    const regex = /<a href="([^"]+)" data-onclick="jump_to_time" data-jump-time="(\d+)">([^<]+)<\/a>\s*(.+)/g;
    const replacement = `<a href="/watch/${videoId}?time=$2" data-sveltekit-preload-data="off" class="link">$3 $4</a>`;
    const processedHtml = html2.replace(regex, replacement);
    return processedHtml;
  }
  $$payload.out += `<div class="comment svelte-vagsbs">`;
  if (!store_get($$store_subs ??= {}, "$interfaceLowBandwidthMode", interfaceLowBandwidthMode)) {
    $$payload.out += "<!--[-->";
    $$payload.out += `<div class="comment-header svelte-vagsbs"><img class="circle small svelte-vagsbs"${attr("src", proxyGoogleImage(getBestThumbnail(comment.authorThumbnails)))} alt="comment profile"> <div class="comment-info svelte-vagsbs"><a${attr("href", `/channel/${comment.authorId}`)} class="author svelte-vagsbs"><span${attr_class("bold", void 0, { "channel-owner": comment.authorIsChannelOwner })}>${escape_html(comment.author)}</span> <span class="secondary-text">${escape_html(comment.publishedText)}</span></a> <p class="no-margin">${html(commentTimestamps(comment.contentHtml))}</p> <div class="comment-actions svelte-vagsbs"><p class="no-margin no-padding"><i>thumb_up</i> ${escape_html(numberWithCommas(comment.likeCount))}</p> `;
    if (comment.replies && true) {
      $$payload.out += "<!--[-->";
      $$payload.out += `<button class="transparent replies svelte-vagsbs"><i class="white-text">expand_more</i> <span class="white-text">${escape_html(comment.replies.replyCount)} ${escape_html(replyText)}</span></button>`;
    } else {
      $$payload.out += "<!--[!-->";
    }
    $$payload.out += `<!--]--></div></div></div>`;
  } else {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]--> `;
  {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]--></div>`;
  if ($$store_subs) unsubscribe_stores($$store_subs);
  pop();
}
function ShareVideo($$payload, $$props) {
  push();
  var $$store_subs;
  $$payload.out += `<button class="row"><div class="min">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.share.materialiousLink"))}</div></button> <button class="row"><div class="min">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.share.invidiousRedirect"))}</div></button><button class="row"><div class="min">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.share.youtubeLink"))}</div></button>`;
  if ($$store_subs) unsubscribe_stores($$store_subs);
  pop();
}
function _page($$payload, $$props) {
  push();
  var $$store_subs;
  let { data = void 0 } = $$props;
  let playerElement;
  let comments = null;
  data.streamed.comments?.then((streamedComments) => {
    comments = streamedComments;
  });
  let subscribed = false;
  data.streamed.subscribed.then((streamedIsSubbed) => {
    subscribed = streamedIsSubbed;
  });
  let personalPlaylists = null;
  data.streamed.personalPlaylists?.then((streamPlaylists) => personalPlaylists = streamPlaylists);
  activePageStore.set(null);
  let playlistVideos = [];
  let playlist = null;
  let loopPlaylist = false;
  let shufflePlaylist = false;
  let theatreMode = get(playerTheatreModeByDefaultStore);
  let segments = [];
  let pauseTimerSeconds = -1;
  let playerCurrentTime = 0;
  playlistSettingsStore.subscribe((playlistSetting) => {
    if (!data.playlistId) return;
    if (data.playlistId in playlistSetting) {
      loopPlaylist = playlistSetting[data.playlistId].loop;
      shufflePlaylist = playlistSetting[data.playlistId].shuffle;
    }
  });
  function playerSyncEvents(conn) {
    if (playerElement) {
      conn.send({
        events: [
          { type: "seek", time: playerElement.currentTime }
        ]
      });
    }
    if (data.playlistId) {
      conn.send({
        events: [
          { type: "playlist", playlistId: data.playlistId }
        ]
      });
    }
    conn.on("data", (rawData) => {
      const events = rawData;
      events.events.forEach(async (event) => {
        if (!playerElement) return;
        if (event.type === "pause") {
          playerElement.pause();
        } else if (event.type === "play") {
          playerElement.play();
        } else if (event.type === "seek" && event.time) {
          const timeDiff = playerElement.currentTime - event.time;
          if (timeDiff > 5 || timeDiff < -5) {
            playerElement.currentTime = event.time;
          }
        } else if (event.type === "playlist" && event.playlistId && event.playlistId !== data.playlistId) {
          data.playlistId = event.playlistId;
          await loadPlaylist(event.playlistId);
          goToCurrentPlaylistItem();
        }
      });
    });
    if (!playerElement) return;
    playerElement.addEventListener("error", () => {
      if (!playerElement) return;
      conn.send({
        events: [
          { type: "seek", time: playerElement.currentTime },
          { type: "play" }
        ]
      });
    });
    playerElement.addEventListener("pause", () => {
      conn.send({ events: [{ type: "pause" }] });
    });
    playerElement.addEventListener("playing", () => {
      if (!playerElement) return;
      conn.send({
        events: [
          { type: "seek", time: playerElement.currentTime },
          { type: "play" }
        ]
      });
    });
    playerElement.addEventListener("play", () => {
      if (!playerElement) return;
      conn.send({
        events: [
          { type: "seek", time: playerElement.currentTime },
          { type: "play" }
        ]
      });
    });
    playerElement.addEventListener("waiting", () => {
      conn.send({ events: [{ type: "pause" }] });
    });
    playerElement.addEventListener("seeked", () => {
      if (!playerElement) return;
      conn.send({
        events: [
          { type: "seek", time: playerElement.currentTime }
        ]
      });
    });
  }
  syncPartyConnectionsStore.subscribe((connections) => {
    if (!connections || !playerElement) return;
    playerSyncEvents(connections[connections.length - 1]);
  });
  onDestroy(() => {
    document.title = "Materialious";
  });
  async function loadPlaylist(playlistId) {
    for (let page = 1; page < Infinity; page++) {
      const newPlaylist = await getPlaylist(playlistId, page);
      if (page === 1) {
        playlist = newPlaylist;
      }
      const newVideos = newPlaylist.videos;
      if (newVideos.length === 0) {
        break;
      }
      playlistVideos = [...playlistVideos, ...newVideos].sort((a, b) => {
        return a.index < b.index ? -1 : 1;
      });
      playlistVideos = playlistVideos.filter((playlistVideo) => {
        return playlistVideo.lengthSeconds > 0;
      });
    }
  }
  async function goToCurrentPlaylistItem() {
    await tick();
    const playlistCurrentVideo = document.getElementById(data.video.videoId);
    const playlistScrollable = document.getElementById("playlist");
    if (playlistCurrentVideo && playlistScrollable) {
      playlistScrollable.scrollTop = playlistCurrentVideo.offsetTop - playlistScrollable.offsetTop - 200;
    }
  }
  let $$settled = true;
  let $$inner_payload;
  function $$render_inner($$payload2) {
    head($$payload2, ($$payload3) => {
      $$payload3.title = `<title>${escape_html(data.video.title)} | Materialious</title>`;
    });
    $$payload2.out += `<div class="space"></div> <div class="grid svelte-p4gn7t"><div${attr_class(`s12 m12 l${theatreMode ? "12" : "9"}`, "svelte-p4gn7t")}><div style="display: flex;justify-content: center;" class="svelte-p4gn7t"><!---->`;
    {
      Player($$payload2, {
        data,
        isSyncing: store_get($$store_subs ??= {}, "$syncPartyPeerStore", syncPartyPeerStore) !== null,
        get playerElement() {
          return playerElement;
        },
        set playerElement($$value) {
          playerElement = $$value;
          $$settled = false;
        },
        get segments() {
          return segments;
        },
        set segments($$value) {
          segments = $$value;
          $$settled = false;
        }
      });
    }
    $$payload2.out += `<!----></div> `;
    {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--> <h5>${escape_html(letterCase(data.video.title))}</h5> <div class="grid no-padding svelte-p4gn7t"><div class="s12 m12 l5"><nav><a${attr("href", `/channel/${data.video.authorId}`)}><nav>`;
    if (!store_get($$store_subs ??= {}, "$interfaceLowBandwidthMode", interfaceLowBandwidthMode)) {
      $$payload2.out += "<!--[-->";
      $$payload2.out += `<img class="circle large"${attr("src", proxyGoogleImage(getBestThumbnail(data.video.authorThumbnails)))} alt="Channel profile">`;
    } else {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--> <div><p style="margin: 0;" class="bold">${escape_html(truncate(data.video.author, 16))}</p> <p style="margin: 0;">${escape_html(data.video.subCountText)}</p></div></nav></a> `;
    if (store_get($$store_subs ??= {}, "$authStore", authStore)) {
      $$payload2.out += "<!--[-->";
      $$payload2.out += `<button${attr_class("svelte-p4gn7t", void 0, {
        "inverse-surface": !subscribed,
        "border": subscribed
      })}>`;
      if (!subscribed) {
        $$payload2.out += "<!--[-->";
        $$payload2.out += `${escape_html(store_get($$store_subs ??= {}, "$_", $format)("subscribe"))}`;
      } else {
        $$payload2.out += "<!--[!-->";
        $$payload2.out += `${escape_html(store_get($$store_subs ??= {}, "$_", $format)("unsubscribe"))}`;
      }
      $$payload2.out += `<!--]--></button>`;
    } else {
      $$payload2.out += "<!--[!-->";
      $$payload2.out += `<button class="inverse-surface svelte-p4gn7t" disabled>${escape_html(store_get($$store_subs ??= {}, "$_", $format)("subscribe"))} <div class="tooltip">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("loginRequired"))}</div></button>`;
    }
    $$payload2.out += `<!--]--></nav></div> <div class="s12 m12 l7 video-actions svelte-p4gn7t"><!---->`;
    await_block(
      data.streamed.returnYTDislikes,
      () => {
      },
      (returnYTDislikes) => {
        if (returnYTDislikes) {
          $$payload2.out += "<!--[-->";
          $$payload2.out += `<nav class="no-space" style="margin-right: .5em;"><button style="cursor: default;" class="border left-round svelte-p4gn7t"><i class="small">thumb_up</i> <span>${escape_html(cleanNumber(returnYTDislikes.likes))}</span></button> <button style="cursor: default;" class="border right-round svelte-p4gn7t"><i class="small">thumb_down_alt</i> <span>${escape_html(cleanNumber(returnYTDislikes.dislikes))}</span></button></nav>`;
        } else {
          $$payload2.out += "<!--[!-->";
          $$payload2.out += `<button style="cursor: default;" class="border svelte-p4gn7t"><i class="small">thumb_up</i> <span>${escape_html(cleanNumber(data.video.likeCount))}</span></button>`;
        }
        $$payload2.out += `<!--]-->`;
      }
    );
    $$payload2.out += `<!----> <div class="svelte-p4gn7t"><button${attr_class("m l svelte-p4gn7t", void 0, { "border": !theatreMode })}><i>width_wide</i> <div class="tooltip">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.theatreMode"))}</div></button> `;
    if (data.video.lengthSeconds > 60 && !data.video.hlsUrl) {
      $$payload2.out += "<!--[-->";
      $$payload2.out += `<button${attr_class("svelte-p4gn7t", void 0, { "border": pauseTimerSeconds < 1 })}><i>schedule</i> <div class="tooltip">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.pauseTimer"))}</div></button>`;
    } else {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--> <button${attr_class("svelte-p4gn7t", void 0, { "border": true })}><i>description</i> <div class="tooltip">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("transcript"))}</div></button> <button class="border svelte-p4gn7t"><i>share</i> <div class="tooltip">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.share.title"))}</div> <menu class="no-wrap mobile">`;
    ShareVideo($$payload2, { video: data.video });
    $$payload2.out += `<!----></menu></button> `;
    if (personalPlaylists) {
      $$payload2.out += "<!--[-->";
      const each_array = ensure_array_like(personalPlaylists);
      $$payload2.out += `<button class="border svelte-p4gn7t"><i>add</i> <div class="tooltip">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.addToPlaylist"))}</div> <menu class="no-wrap mobile"><!--[-->`;
      for (let $$index = 0, $$length = each_array.length; $$index < $$length; $$index++) {
        let personalPlaylist = each_array[$$index];
        $$payload2.out += `<button class="row svelte-p4gn7t"><nav><span class="max">${escape_html(personalPlaylist.title)}</span> `;
        if (personalPlaylist.videos.filter((item) => {
          return item.videoId === data.video.videoId;
        }).length > 0) {
          $$payload2.out += "<!--[-->";
          $$payload2.out += `<i>close</i>`;
        } else {
          $$payload2.out += "<!--[!-->";
          $$payload2.out += `<i>add</i>`;
        }
        $$payload2.out += `<!--]--></nav></button>`;
      }
      $$payload2.out += `<!--]--></menu></button>`;
    } else {
      $$payload2.out += "<!--[!-->";
      $$payload2.out += `<button disabled class="border no-margin svelte-p4gn7t"><i>add</i> <div class="tooltip">`;
      if (store_get($$store_subs ??= {}, "$authStore", authStore)) {
        $$payload2.out += "<!--[-->";
        $$payload2.out += `${escape_html(store_get($$store_subs ??= {}, "$_", $format)("player.noPlaylists"))}`;
      } else {
        $$payload2.out += "<!--[!-->";
        $$payload2.out += `${escape_html(store_get($$store_subs ??= {}, "$_", $format)("loginRequired"))}`;
      }
      $$payload2.out += `<!--]--></div></button>`;
    }
    $$payload2.out += `<!--]--></div></div></div> <article><details><summary id="description" class="bold none"><nav><div class="max">${escape_html(numberWithCommas(data.video.viewCount))} views • ${escape_html(data.video.publishedText)}</div> <i>expand_more</i></nav></summary> <div class="space"></div> <div class="medium scroll"><div style="white-space: pre-line; overflow-wrap: break-word;">${html(data.content.description)}</div> `;
    if (data.content) {
      $$payload2.out += "<!--[-->";
      if (data.content.timestamps.length > 0) {
        $$payload2.out += "<!--[-->";
        const each_array_1 = ensure_array_like(data.content.timestamps);
        $$payload2.out += `<h6 style="margin-bottom: .3em;">Chapters</h6> <!--[-->`;
        for (let $$index_1 = 0, $$length = each_array_1.length; $$index_1 < $$length; $$index_1++) {
          let timestamp = each_array_1[$$index_1];
          $$payload2.out += `<button class="timestamps svelte-p4gn7t">${escape_html(timestamp.timePretty)} `;
          if (!timestamp.title.startsWith("-")) {
            $$payload2.out += "<!--[-->";
            $$payload2.out += `-`;
          } else {
            $$payload2.out += "<!--[!-->";
          }
          $$payload2.out += `<!--]--> ${escape_html(timestamp.title)}</button>`;
        }
        $$payload2.out += `<!--]-->`;
      } else {
        $$payload2.out += "<!--[!-->";
      }
      $$payload2.out += `<!--]-->`;
    } else {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--></div> <nav class="scroll">`;
    if (data.video.keywords) {
      $$payload2.out += "<!--[-->";
      const each_array_2 = ensure_array_like(data.video.keywords);
      $$payload2.out += `<!--[-->`;
      for (let $$index_2 = 0, $$length = each_array_2.length; $$index_2 < $$length; $$index_2++) {
        let keyword = each_array_2[$$index_2];
        $$payload2.out += `<a${attr("href", `/search/${encodeURIComponent(keyword)}`)} class="chip">${escape_html(keyword)}</a>`;
      }
      $$payload2.out += `<!--]-->`;
    } else {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--></nav></details></article> `;
    if (comments && comments.comments.length > 0) {
      $$payload2.out += "<!--[-->";
      const each_array_3 = ensure_array_like(comments.comments);
      $$payload2.out += `<article><details><summary id="comment-section" class="none bold"><nav><div class="max">${escape_html(numberWithCommas(comments.commentCount))} comments</div> <i>expand_more</i></nav></summary> <div class="space"></div> <div class="medium scroll"><!--[-->`;
      for (let $$index_3 = 0, $$length = each_array_3.length; $$index_3 < $$length; $$index_3++) {
        let comment = each_array_3[$$index_3];
        Comment($$payload2, { comment, videoId: data.video.videoId });
      }
      $$payload2.out += `<!--]--> `;
      if (comments.continuation) {
        $$payload2.out += "<!--[-->";
        $$payload2.out += `<button class="margin svelte-p4gn7t">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("loadMore"))}</button>`;
      } else {
        $$payload2.out += "<!--[!-->";
      }
      $$payload2.out += `<!--]--></div></details></article>`;
    } else {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--></div> `;
    if (!theatreMode) {
      $$payload2.out += "<!--[-->";
      $$payload2.out += `<div class="s12 m12 l3">`;
      {
        $$payload2.out += "<!--[!-->";
      }
      $$payload2.out += `<!--]--> `;
      if (playlist) {
        $$payload2.out += "<!--[-->";
        const each_array_4 = ensure_array_like(playlistVideos);
        $$payload2.out += `<article style="height: 85vh; position: relative;" id="playlist" class="scroll no-padding surface-container-high"><article class="no-elevate" style="position: sticky; top: 0; z-index: 3;"><h6>${escape_html(playlist.title)}</h6> <p>${escape_html(cleanNumber(playlist.viewCount))}
							${escape_html(store_get($$store_subs ??= {}, "$_", $format)("views"))} • ${escape_html(playlist.videoCount)}
							${escape_html(store_get($$store_subs ??= {}, "$_", $format)("videos"))}</p> <p><a${attr("href", `/channel/${playlist.authorId}`)}>${escape_html(playlist.author)}</a></p> <nav><button${attr_class("circle", void 0, { "fill": !loopPlaylist })}><i>loop</i> <div class="tooltip bottom">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("playlist.loopPlaylist"))}</div></button> <button${attr_class("circle", void 0, { "fill": !shufflePlaylist })}><i>shuffle</i> <div class="tooltip bottom">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("playlist.shuffleVideos"))}</div></button></nav> <div class="space"></div> <div class="divider"></div></article> <div class="space"></div> <!--[-->`;
        for (let $$index_4 = 0, $$length = each_array_4.length; $$index_4 < $$length; $$index_4++) {
          let playlistVideo = each_array_4[$$index_4];
          $$payload2.out += `<article${attr_class("no-padding primary-border", void 0, {
            "border": playlistVideo.videoId === data.video.videoId
          })} style="margin: .7em;"${attr("id", playlistVideo.videoId)}><!---->`;
          {
            Thumbnail($$payload2, {
              video: playlistVideo,
              sideways: true,
              playlistId: data.playlistId || void 0
            });
          }
          $$payload2.out += `<!----></article>`;
        }
        $$payload2.out += `<!--]--></article>`;
      } else if (data.video.recommendedVideos) {
        $$payload2.out += "<!--[1-->";
        const each_array_5 = ensure_array_like(data.video.recommendedVideos);
        $$payload2.out += `<!--[-->`;
        for (let $$index_5 = 0, $$length = each_array_5.length; $$index_5 < $$length; $$index_5++) {
          let recommendedVideo = each_array_5[$$index_5];
          $$payload2.out += `<article class="no-padding"><!---->`;
          {
            Thumbnail($$payload2, { video: recommendedVideo, sideways: true });
          }
          $$payload2.out += `<!----></article>`;
        }
        $$payload2.out += `<!--]-->`;
      } else {
        $$payload2.out += "<!--[!-->";
      }
      $$payload2.out += `<!--]--></div>`;
    } else {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--></div> <dialog class="modal" id="pause-timer"><div class="field middle-align"><label class="slider"><input type="range"${attr("value", pauseTimerSeconds)} min="0" step="60"${attr("max", data.video.lengthSeconds - playerCurrentTime - 60)}> <span></span></label> `;
    {
      $$payload2.out += "<!--[!-->";
    }
    $$payload2.out += `<!--]--></div> <nav class="right-align no-space"><button class="transparent link">Cancel</button> <button${attr("disabled", pauseTimerSeconds < 1, true)} class="transparent link">Confirm</button></nav></dialog>`;
  }
  do {
    $$settled = true;
    $$inner_payload = copy_payload($$payload);
    $$render_inner($$inner_payload);
  } while (!$$settled);
  assign_payload($$payload, $$inner_payload);
  if ($$store_subs) unsubscribe_stores($$store_subs);
  bind_props($$props, { data });
  pop();
}
export {
  _page as default
};
