import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
import { FormatId } from "../misc/common.js";
import { TimeRange } from "./time_range.js";
export declare const protobufPackage = "video_streaming";
export interface MediaHeader {
    headerId?: number | undefined;
    videoId?: string | undefined;
    itag?: number | undefined;
    lmt?: number | undefined;
    xtags?: string | undefined;
    startDataRange?: number | undefined;
    compression?: MediaHeader_Compression | undefined;
    isInitSeg?: boolean | undefined;
    sequenceNumber?: number | undefined;
    field10?: number | undefined;
    startMs?: number | undefined;
    durationMs?: number | undefined;
    formatId?: FormatId | undefined;
    contentLength?: number | undefined;
    timeRange?: TimeRange | undefined;
}
export declare enum MediaHeader_Compression {
    VAL0 = 0,
    VAL1 = 1,
    GZIP = 2,
    UNRECOGNIZED = -1
}
export declare function mediaHeader_CompressionFromJSON(object: any): MediaHeader_Compression;
export declare function mediaHeader_CompressionToJSON(object: MediaHeader_Compression): string;
export declare const MediaHeader: MessageFns<MediaHeader>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
