import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
import { BufferedRange } from "./buffered_range.js";
import { ClientAbrState } from "./client_abr_state.js";
import { EncryptedPlayerRequest } from "./encrypted_player_request.js";
import { StreamerContext } from "./streamer_context.js";
export declare const protobufPackage = "video_streaming";
export interface OnesieRequest {
    urls: string[];
    clientAbrState?: ClientAbrState | undefined;
    playerRequest?: EncryptedPlayerRequest | undefined;
    onesieUstreamerConfig?: Uint8Array | undefined;
    maxVp9Height?: number | undefined;
    clientDisplayHeight?: number | undefined;
    streamerContext?: StreamerContext | undefined;
    bufferedRanges: BufferedRange[];
}
export declare const OnesieRequest: MessageFns<OnesieRequest>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
